package me.Demon.DemonMmKillsDrop.manager;

import java.util.HashMap;
import java.util.Map;
import java.util.UUID;

public class DamageManager {

    private static Map<UUID, Map<UUID, Double>> damageMap = new HashMap<>();

    public static Map<UUID, Map<UUID, Double>> getDamageMap() {
        return damageMap;
    }

    public static Map<UUID, Double> getEntityDamageMap(UUID entity) {
        Map<UUID, Double> map = new HashMap<>();
        damageMap.forEach((p, m) -> {
            if (m.containsKey(entity)) {
                map.put(p, m.get(entity));
            }
        });
        return map;
    }

    public static double getDamage(UUID player, UUID entity) {
        if (!damageMap.containsKey(player)) {
            return 0;
        }
        return damageMap.get(player).getOrDefault(entity, (double) 0);
    }

    public static void damage(UUID player, UUID entity, double damage) {
        Map<UUID, Double> map = damageMap.getOrDefault(player, new HashMap<>());
        map.put(entity, map.getOrDefault(entity, (double) 0) + damage);
        damageMap.put(player, map);
    }

    public static void clearEntity(UUID entity) {
        damageMap.forEach((p, map)->{
            if (map.containsKey(entity)) {
                map.remove(entity);
            }
        });
    }

}
